#pragma once
#include "NumEdit.h"
#include "loggable.h"
#include "Modeless.h"

// Maella: This class is designed to keep the fingers away from the *.rc files.
//         It should simplify the porting to new versions of the eMule.

// CPPgMaella dialog
class CPPgMaella : public CPreferencesPage, public CLoggable // [TPT] - SLUGFILLER: modelessDialogs
{
	DECLARE_DYNAMIC(CPPgMaella)

public:
	CPPgMaella();
	virtual ~CPPgMaella();

	void Localize(void);
	void LoadSettings();

// Dialog Data
	enum { IDD = IDD_PPG_MAELLA };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()

public:
	virtual BOOL OnApply();
	virtual BOOL OnInitDialog();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSettingsChange() { SetModified(TRUE); }
	afx_msg void OnTabSelectionChange(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnCorruptionCheckChange();
	afx_msg void OnUpdateIPFilterURLChange();
	afx_msg void OnMultiQueueChange();
	afx_msg void OnNAFCChange();

private:
	enum eTab {NONE, GENERAL, DISPLAY, CONNECTION, 
		       SERVER, DIR, FILES, EKDEV_OPTIONS, 
			   STATSSETUPINFO, IRC, PW_WS, SECURITY, TWEAK};
	void SetTab(eTab tab);

	void InitTab();
	void InitControl();	

	// Tab
	CImageList m_imageList;
	CTabCtrl   m_tabCtr;
	eTab       m_currentTab;

	// CONNECTION
	CButton m_compOverheadCheck;
	
	CEdit   m_MTUEdit;
	CStatic m_MTUStatic;

	CEdit   m_minSlotEdit;
	CStatic m_minSlotStatic;

	CEdit   m_sndSocketSizeEdit;
	CStatic m_sndSocketSizeStatic;

	CButton  m_NAFCGroupBox;
	CStatic  m_NAFCStatic;
	CButton  m_NAFCCheck01;
	CButton  m_NAFCCheck02;
	CNumEdit m_NAFCEdit;

	CStatic m_connectionStatic;
	//[TPT]-Cumulate Bandwidth
	CButton	 m_iCumulateBW;

	// FILES
	CButton m_multiQueueGroupBox;
	CButton m_multiQueueCheck01;
	CButton m_multiQueueCheck02;

	CButton m_A4AFBox;
	CButton m_A4AFCheck;

    CButton m_newUploadSlotSharpingCheck;

	// SECURITY
	CButton m_corruptionGroupBox;
	CButton m_corruptionCheck;
	CButton m_skipCorruptionCDCheck;
	
	CButton m_IPFilterGroupBox;
	CStatic m_IPFilterVersionStatic;
	CButton m_IPFilterUpdateButton;

	// [TPT] - Ipfilter Update
	CEdit   m_URLForUpdate;
	CStatic m_URLForUpdateStatic;

	//eWombat [SNAFU][TPT]
	CButton  m_SnafuGroupBox;
	CButton  m_iSnafu;
	CButton	 m_iAntiFriendshare;
	CButton  m_iAntiCreditTheft;


	CStatic m_userHashStatic;
	CEdit   m_userHashEdit;

	// STATSSETUPINFO
	CButton m_zoomGroupBox;
	CStatic m_zoomStatic;

	CSliderCtrl m_zoomSlider;

	CButton     m_sampleRateGroupBox;
	CStatic     m_sampleRateStatic;
	CSliderCtrl m_sampleRateSlider;

	// SERVER
	CButton m_XSCheck;

	CButton m_reaskSourceAfterIPChangeCheck;

	// TWEAK
	CButton m_filterVerboseGroupbox;
	CButton m_filterVerboseCheck01;
	//CButton m_filterVerboseCheck02;
	//CButton m_filterVerboseCheck03;
	CButton m_filterVerboseCheck04;
	CButton m_filterVerboseCheck05;
	CButton m_filterVerboseCheck06;
	CButton m_filterVerboseCheck07;
	CButton m_filterVerboseCheck08;
	CButton m_filterVerboseCheck09;
	CButton m_filterVerboseCheck10;

	CStatic m_miniDumpStatic;
};