//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#include "stdafx.h"
#include "emule.h"
#include "SharedFilesWnd.h"
#include "OtherFunctions.h"
#include "SharedFileList.h"
#include "KnownFileList.h"
#include "KnownFile.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CSharedFilesWnd dialog

IMPLEMENT_DYNAMIC(CSharedFilesWnd, CDialog)
CSharedFilesWnd::CSharedFilesWnd(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CSharedFilesWnd::IDD, pParent)
{
	md4clr(shownFileHash);
	icon_files = NULL;
}

CSharedFilesWnd::~CSharedFilesWnd()
{
	if (icon_files)
		VERIFY( DestroyIcon(icon_files) );
}

void CSharedFilesWnd::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SFLIST, sharedfilesctrl);
	DDX_Control(pDX, IDC_POPBAR, pop_bar);
	DDX_Control(pDX, IDC_POPBAR2, pop_baraccept);
	DDX_Control(pDX, IDC_POPBAR3, pop_bartrans);
	DDX_Control(pDX, IDC_STATISTICS, m_ctrlStatisticsFrm);
	//emulEspaa: Added by [TPT]-MoNKi [MoNKi: -Downloaded History-]
	DDX_Control(pDX, IDC_DOWNHISTORYLIST, historylistctrl);
	DDX_Control(pDX, IDC_BTN_CHANGEVIEW, m_btnChangeView);
	//End emulEspaa
}

BOOL CSharedFilesWnd::OnInitDialog()
{
	CResizableDialog::OnInitDialog();
	InitWindowStyles(this);
	SetAllIcons();
	sharedfilesctrl.Init();
	
	// [TPT] - MoNKi: -Support for High Contrast Mode-
	COLORREF clrStart, clrEnd, clrBarText, midColor;

	clrStart = ::GetSysColor(COLOR_HIGHLIGHT);
	clrEnd = ::GetHighContrastColor(::GetSysColor(COLOR_3DFACE), ::GetSysColor(COLOR_HIGHLIGHTTEXT));

	midColor = RGB((GetRValue(clrStart) + GetRValue(clrEnd))/2,
		(GetGValue(clrStart) + GetGValue(clrEnd))/2,
		(GetBValue(clrStart) + GetBValue(clrEnd))/2);

	clrBarText = ::GetHighContrastColor(midColor, ::GetSysColor(COLOR_HIGHLIGHTTEXT));

	pop_bar.SetGradientColors(clrStart,clrEnd);
	pop_bar.SetTextColor(clrBarText, ::GetSysColor(COLOR_BTNTEXT));
	pop_baraccept.SetGradientColors(clrStart,clrEnd);
	pop_baraccept.SetTextColor(clrBarText, ::GetSysColor(COLOR_BTNTEXT));
	pop_bartrans.SetGradientColors(clrStart,clrEnd);
	pop_bartrans.SetTextColor(clrBarText, ::GetSysColor(COLOR_BTNTEXT));
	// [TPT] - MoNKi: -Support for High Contrast Mode-

	LOGFONT lf;
	GetFont()->GetLogFont(&lf);
	lf.lfWeight = FW_BOLD;
	bold.CreateFontIndirect(&lf);
	m_ctrlStatisticsFrm.Init("Statistics");
    m_ctrlStatisticsFrm.SetFont(&bold); // should run Init() *first* before setting font bold. 
    m_ctrlStatisticsFrm.SetText(GetResString(IDS_SF_STATISTICS)); // i_a: XXX: moved here from 'Localize()' 
    
	Localize();

	GetDlgItem(IDC_CURSESSION_LBL)->SetFont(&bold);
	GetDlgItem(IDC_TOTAL_LBL)->SetFont(&bold);
	
	//emulEspaa: Added by [TPT]-MoNKi [MoNKi: -Downloaded History-]
	CRect tmpRect,tmpRect2;
	
	GetDlgItem(IDC_BTN_CHANGEVIEW)->GetWindowRect(tmpRect);
	GetDlgItem(IDC_FILES_ICO)->GetWindowRect(tmpRect2);
	ScreenToClient(tmpRect);
	ScreenToClient(tmpRect2);
	tmpRect.MoveToX(tmpRect2.left);
	m_btnChangeView.MoveWindow(tmpRect,true);

	GetDlgItem(IDC_FILES_ICO)->ShowWindow(false);
	GetDlgItem(IDC_TRAFFIC_TEXT)->ShowWindow(false);

	m_btnChangeView.SetIcon("Sharedfiles");
	m_btnChangeView.SetAlign(CButtonST::ST_ALIGN_HORIZ);
	m_btnChangeView.SetFlat();
	m_btnChangeView.SetLeftAlign(true); 
	
	sharedfilesctrl.GetWindowRect(tmpRect);
	ScreenToClient(tmpRect);
	historylistctrl.MoveWindow(tmpRect,true);
	historylistctrl.ShowWindow(false);
	historylistctrl.Init();
	
	AddAnchor(IDC_BTN_CHANGEVIEW,TOP_LEFT);
	AddAnchor(IDC_DOWNHISTORYLIST,TOP_LEFT,BOTTOM_RIGHT);
	// End emulEspaa


	AddAnchor(IDC_TRAFFIC_TEXT, TOP_LEFT);
	AddAnchor(IDC_SFLIST,TOP_LEFT,BOTTOM_RIGHT);
	AddAnchor(IDC_RELOADSHAREDFILES, BOTTOM_RIGHT);
	AddAnchor(IDC_BROWSELOCALFILES, BOTTOM_RIGHT);	// [TPT] - itsonlyme: viewSharedFiles
	AddAnchor(IDC_STATISTICS,BOTTOM_LEFT);
	AddAnchor(IDC_CURSESSION_LBL, BOTTOM_LEFT);
	AddAnchor(IDC_TOTAL_LBL, BOTTOM_LEFT);
	AddAnchor(IDC_FSTATIC4, BOTTOM_LEFT);
	AddAnchor(IDC_SREQUESTED,BOTTOM_LEFT);
	AddAnchor(IDC_POPBAR,BOTTOM_LEFT);
	AddAnchor(IDC_FSTATIC7,BOTTOM_LEFT);
	AddAnchor(IDC_SREQUESTED2,BOTTOM_LEFT);
	AddAnchor(IDC_FSTATIC5,BOTTOM_LEFT);
	AddAnchor(IDC_SACCEPTED,BOTTOM_LEFT);
	AddAnchor(IDC_POPBAR2,BOTTOM_LEFT);
	AddAnchor(IDC_FSTATIC8,BOTTOM_LEFT);
	AddAnchor(IDC_SACCEPTED2,BOTTOM_LEFT);
	AddAnchor(IDC_FSTATIC6,BOTTOM_LEFT);
	AddAnchor(IDC_STRANSFERED,BOTTOM_LEFT);
	AddAnchor(IDC_POPBAR3,BOTTOM_LEFT);
	AddAnchor(IDC_FSTATIC9,BOTTOM_LEFT);
	AddAnchor(IDC_STRANSFERED2,BOTTOM_LEFT);
	
	return TRUE;
}

void CSharedFilesWnd::Reload()
{
	theApp.sharedfiles->Reload();
	if (theApp.sharedfiles->GetFileByID(shownFileHash) == NULL)
		ShowDetails(NULL);
}

BEGIN_MESSAGE_MAP(CSharedFilesWnd, CResizableDialog)
	ON_BN_CLICKED(IDC_RELOADSHAREDFILES, OnBnClickedReloadsharedfiles)
	ON_BN_CLICKED(IDC_BROWSELOCALFILES, OnBnClickedBrowseLocalFiles)	// [TPT] - itsonlyme: viewSharedFiles
	ON_NOTIFY(LVN_ITEMACTIVATE, IDC_SFLIST, OnLvnItemActivateSflist)
	ON_NOTIFY(NM_CLICK, IDC_SFLIST, OnNMClickSflist)
	//emulEspaa: Added by [TPT]-MoNKi [MoNKi: -Downloaded History-]
	ON_NOTIFY(LVN_ITEMACTIVATE, IDC_DOWNHISTORYLIST, OnLvnItemActivateHistorylist)
	ON_NOTIFY(NM_CLICK, IDC_DOWNHISTORYLIST, OnNMClickHistorylist)
	ON_BN_CLICKED(IDC_BTN_CHANGEVIEW, OnBnClickedBtnChangeview)
	//End emulEspaa
	ON_WM_SYSCOLORCHANGE()
END_MESSAGE_MAP()


// CSharedFilesWnd message handlers

void CSharedFilesWnd::OnBnClickedReloadsharedfiles()
{
	Reload();
}

// [TPT] - itsonlyme: viewSharedFiles
void CSharedFilesWnd::OnBnClickedBrowseLocalFiles()
{
	theApp.sharedfiles->ShowLocalFilesDialog();
}
// [TPT] - itsonlyme: viewSharedFiles

void CSharedFilesWnd::Check4StatUpdate(const CKnownFile* file)
{
	if (!md4cmp(file->GetFileHash(), shownFileHash))
		ShowDetails(file);
}

void CSharedFilesWnd::OnLvnItemActivateSflist(NMHDR *pNMHDR, LRESULT *pResult)
{
	int iSel = sharedfilesctrl.GetNextItem(-1, LVIS_SELECTED | LVIS_FOCUSED);
	if (iSel != -1) {
		const CKnownFile* cur_file = (CKnownFile*)sharedfilesctrl.GetItemData(iSel);
		ShowDetails(cur_file);
	}
	else
		ShowDetails(NULL);
}

void CSharedFilesWnd::ShowDetails(const CKnownFile* cur_file)
{
	if (cur_file)
	{
		CString buffer;

		pop_bartrans.SetRange32(0,theApp.knownfiles->transferred/1024);
		pop_bartrans.SetPos(cur_file->statistic.GetTransferred()/1024);
		pop_bartrans.SetShowPercent();			
		GetDlgItem(IDC_STRANSFERED)->SetWindowText(CastItoXBytes(cur_file->statistic.GetTransferred()));

		pop_bar.SetRange32(0,theApp.knownfiles->requested);
		pop_bar.SetPos(cur_file->statistic.GetRequests());
		pop_bar.SetShowPercent();			
		buffer.Format("%u",cur_file->statistic.GetRequests());
		GetDlgItem(IDC_SREQUESTED)->SetWindowText(buffer);

		buffer.Format("%u",cur_file->statistic.GetAccepts());
		pop_baraccept.SetRange32(0,theApp.knownfiles->accepted);
		pop_baraccept.SetPos(cur_file->statistic.GetAccepts());
		pop_baraccept.SetShowPercent();
		GetDlgItem(IDC_SACCEPTED)->SetWindowText(buffer);

		GetDlgItem(IDC_STRANSFERED2)->SetWindowText(CastItoXBytes(cur_file->statistic.GetAllTimeTransferred()));

		buffer.Format("%u",cur_file->statistic.GetAllTimeRequests());
		GetDlgItem(IDC_SREQUESTED2)->SetWindowText(buffer);

		buffer.Format("%u",cur_file->statistic.GetAllTimeAccepts());
		GetDlgItem(IDC_SACCEPTED2)->SetWindowText(buffer);

		md4cpy(shownFileHash,cur_file->GetFileHash());

		CString title=GetResString(IDS_SF_STATISTICS)+" ("+ MakeStringEscaped(cur_file->GetFileName()) +")";
		m_ctrlStatisticsFrm.SetText(title);
	}
	else
	{
		pop_bartrans.SetRange32(0, 100);
		pop_bartrans.SetPos(0);
		pop_bartrans.SetTextFormat(_T(""));
		GetDlgItem(IDC_STRANSFERED)->SetWindowText(_T("-"));

		pop_bar.SetRange32(0, 100);
		pop_bar.SetPos(0);
		pop_bar.SetTextFormat(_T(""));
		GetDlgItem(IDC_SREQUESTED)->SetWindowText(_T("-"));

		pop_baraccept.SetRange32(0, 100);
		pop_baraccept.SetPos(0);
		pop_baraccept.SetTextFormat(_T(""));
		GetDlgItem(IDC_SACCEPTED)->SetWindowText(_T("-"));

		GetDlgItem(IDC_STRANSFERED2)->SetWindowText(_T("-"));
		GetDlgItem(IDC_SREQUESTED2)->SetWindowText(_T("-"));
		GetDlgItem(IDC_SACCEPTED2)->SetWindowText(_T("-"));

		md4clr(shownFileHash);
		m_ctrlStatisticsFrm.SetText(GetResString(IDS_SF_STATISTICS));
	}
}

void CSharedFilesWnd::OnNMClickSflist(NMHDR *pNMHDR, LRESULT *pResult)
{
	OnLvnItemActivateSflist(pNMHDR,pResult);
	*pResult = 0;
}

BOOL CSharedFilesWnd::PreTranslateMessage(MSG* pMsg) 
{
   if(pMsg->message == WM_KEYUP){
	   if (pMsg->hwnd == GetDlgItem(IDC_SFLIST)->m_hWnd)
			OnLvnItemActivateSflist(0,0);
   }
   if (pMsg->message == WM_MBUTTONUP){
		POINT point;
		::GetCursorPos(&point);
		CPoint p = point; 
		sharedfilesctrl.ScreenToClient(&p); 
		int it = sharedfilesctrl.HitTest(p); 
		if (it == -1)
			return FALSE;

		sharedfilesctrl.SetSelectionMark(it);   // display selection mark correctly! 
		sharedfilesctrl.ShowComments((CKnownFile*)sharedfilesctrl.GetItemData(it));
		return TRUE;
   }

   return CResizableDialog::PreTranslateMessage(pMsg);
}

void CSharedFilesWnd::OnSysColorChange()
{
	CResizableDialog::OnSysColorChange();
	SetAllIcons();
}

void CSharedFilesWnd::SetAllIcons()
{
	if (icon_files)
		VERIFY( DestroyIcon(icon_files) );
	icon_files = theApp.LoadIcon("SharedFiles", 16, 16);
	((CStatic*)GetDlgItem(IDC_FILES_ICO))->SetIcon(icon_files);
}

void CSharedFilesWnd::Localize()
{
	sharedfilesctrl.Localize();
	//emulEspaa: Added by [TPT]-MoNKi [MoNKi: -Downloaded History-]
	historylistctrl.Localize();
	//End emulEspaa
	GetDlgItem(IDC_TRAFFIC_TEXT)->SetWindowText(GetResString(IDS_SF_FILES));
	GetDlgItem(IDC_RELOADSHAREDFILES)->SetWindowText(GetResString(IDS_SF_RELOAD));
	GetDlgItem(IDC_BROWSELOCALFILES)->SetWindowText(GetResString(IDS_SF_BROWSELOCAL));	// [TPT] - itsonlyme: viewSharedFiles

	m_ctrlStatisticsFrm.SetWindowText(GetResString(IDS_SF_STATISTICS));
	m_ctrlStatisticsFrm.SetText(GetResString(IDS_SF_STATISTICS));	
	
	GetDlgItem(IDC_CURSESSION_LBL)->SetWindowText(GetResString(IDS_SF_CURRENT));
	GetDlgItem(IDC_TOTAL_LBL)->SetWindowText(GetResString(IDS_SF_TOTAL));
	GetDlgItem(IDC_FSTATIC6)->SetWindowText(GetResString(IDS_SF_TRANS));
	GetDlgItem(IDC_FSTATIC5)->SetWindowText(GetResString(IDS_SF_ACCEPTED));
	GetDlgItem(IDC_FSTATIC4)->SetWindowText(GetResString(IDS_SF_REQUESTS)+":");
	GetDlgItem(IDC_FSTATIC9)->SetWindowText(GetResString(IDS_SF_TRANS));
	GetDlgItem(IDC_FSTATIC8)->SetWindowText(GetResString(IDS_SF_ACCEPTED));
	GetDlgItem(IDC_FSTATIC7)->SetWindowText(GetResString(IDS_SF_REQUESTS)+":");
	//emulEspaa: Added by [TPT]-MoNKi [MoNKi: -Downloaded History-]
	if(!historylistctrl.IsWindowVisible())
		m_btnChangeView.SetWindowText(GetResString(IDS_SF_FILES));
	else
		m_btnChangeView.SetWindowText(GetResString(IDS_DOWNHISTORY));
	//End emulEspaa
}

//emulEspaa: Added by [TPT]-MoNKi [MoNKi: -Downloaded History-]
void CSharedFilesWnd::OnBnClickedBtnChangeview()
{
	if(historylistctrl.IsWindowVisible()){
		m_btnChangeView.SetIcon("Sharedfiles");
		m_btnChangeView.SetWindowText(GetResString(IDS_SF_FILES));
		sharedfilesctrl.ShowWindow(true);
		historylistctrl.ShowWindow(false);
		GetDlgItem(IDC_RELOADSHAREDFILES)->ShowWindow(true);
	}
	else
	{
		m_btnChangeView.SetIcon("Directdownload");		
		m_btnChangeView.SetWindowText(GetResString(IDS_DOWNHISTORY));
		historylistctrl.ShowWindow(true);
		sharedfilesctrl.ShowWindow(false);
		GetDlgItem(IDC_RELOADSHAREDFILES)->ShowWindow(false);
	}
}

void CSharedFilesWnd::OnNMClickHistorylist(NMHDR *pNMHDR, LRESULT *pResult){
	OnLvnItemActivateHistorylist(pNMHDR,pResult);
	*pResult = 0;
}

void CSharedFilesWnd::OnLvnItemActivateHistorylist(NMHDR *pNMHDR, LRESULT *pResult)
{
	if (historylistctrl.GetSelectionMark() != (-1) ) {
		CKnownFile* cur_file = (CKnownFile*)historylistctrl.GetItemData(historylistctrl.GetSelectionMark());

		ShowDetails(cur_file);
	}
}
//end emulEspaa
